#!/bin/sh
# Copy the correct vstusb file to the /lib/modules/<kernelversion>/kernel/drivers/usb/misc directory
#
# parameter is the currently executing version of the kernel + path to this script.  e.g.:
#
# copy_usb_driver 2.16.24-19-generic /home/gupshaw/Desktop/Opus/Support/linux_vstusb

# Make sure destination directory exists
if [ $# = 2 ] && [ -d /lib/modules/$1 ] && [ -d $2 ]
then
    cp $2$1/vstusb.ko /lib/modules/$1/kernel/drivers/usb/misc
    cp $2/source/vstusb.rules /etc/udev/rules.d
    depmod -A
else
    echo "$1 or $2 are not valid folders!"
fi

