
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/ioctl.h>

#ifndef __user
#define __user
#endif

#include "vstusb.h"

#define IOCTL_VSTUSB_GET_STATS	_IO(VST_IOC_MAGIC, VST_IOC_FIRST + 3)
#define IOCTL_VSTUSB_CLR_STATS	_IO(VST_IOC_MAGIC, VST_IOC_FIRST + 4)

#if 0
#define STATS_ON 1		// prerequisite for the following include
#endif

static int open_vst_dev();

int main(int argc, char * argv[])
{
	int retval;
    struct vstusb_args        usb_data;
	int dev = -1;			//device file pointer

	if ((dev = open_vst_dev()) == -1) {
		return -1;
	}

	printf("%s: open succeeded (%d)\n", __FUNCTION__, dev);

    // Dump driver statistics
    retval = ioctl(dev, IOCTL_VSTUSB_GET_STATS, &usb_data);

    retval = ioctl(dev, IOCTL_VSTUSB_CLR_STATS, &usb_data);
    
	if (close(dev) < 0) {
		printf("%s: close err /dev/usb/vstusb (%d)", __FUNCTION__, retval);
		return -1;
	}

	return 0;
}


static int open_vst_dev()
{
	int dev = -1;

	if ((dev = open("/dev/vstusb0", O_RDWR)) == -1) {
		printf("%s: can't open /dev/vstusb0 (dev=%d, errno=%s)\n", __FUNCTION__, dev, strerror(errno));
		return dev;
	}

	return dev;
}

