#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <sys/ioctl.h>

#ifndef __user
#define __user
#endif

#include "vstusb.h"

#define OFF	0
#define ON	1

#define EP2  2
#define EP7  7

#define NDR_TIMEOUT     5

//globals
char	*TestFileName;

static int open_vstusb_dev();
static int initialize(int dev);

int parse_cmdline (argc, argv)
{
	if (argc != 2) {
//		printf("invalid number of arguments to test program");
//		return -1;
	}

	TestFileName = NULL;

	return 0;
}

int main(int argc, char *argv[])
{
	int size;
	int i, retval=0;
	int dev = -1;			//device file pointer
    int writeFlag=1;
    struct vstusb_args usb_data;
    char writeBuf[4096]="nowisthetime";
    char readBuf[4096]="";

	if (parse_cmdline(argc, argv) != 0)
		return -1;

	if ((dev = open_vstusb_dev()) == -1) {
		return -1;
	}

    printf("%s: START\n", __FUNCTION__);
//    goto readonly;
loop:

    usb_data.timeout_ms = 100000;
    usb_data.buffer = (void *)writeBuf;
    usb_data.count = 13;
    usb_data.pipe = 2;

    printf("%s: do write\n", __FUNCTION__);

    if ((retval = ioctl((int)dev, IOCTL_VSTUSB_SEND_PIPE, &usb_data)) != 0) {
        printf("%s: no can write, error is %s\n", __FUNCTION__,strerror(errno));
        goto exit;
    }

readonly:
    usb_data.timeout_ms = 0;
    usb_data.buffer = (void *)readBuf;
    usb_data.count = 4096;
    usb_data.pipe = 1;

    printf("%s: do read\n", __FUNCTION__);

    if ((retval = ioctl((int)dev, IOCTL_VSTUSB_RECV_PIPE, &usb_data)) != 0) {
        printf("%s: no can read, error is %s\n", __FUNCTION__,strerror(errno));
        goto exit;
    }
    else {
        printf("%s: received: %s\n", __FUNCTION__, readBuf);
        readBuf[0]='\0';
//        goto readonly;
        goto loop;
    }

exit:
	if (close(dev) < 0) {
		printf("%s: close err /dev/vstusb (%d)", __FUNCTION__, retval);
	}
	return 0;
}

static int open_vstusb_dev()
{
	struct vstusb_args usb_data;
	int dev = -1;
	int retval;

	if ((dev = open("/dev/vstusb0", O_RDWR)) == -1) {
		printf("%s: can't open /dev/vstusb0 (%d), errno = %s\n", __FUNCTION__, dev, strerror(errno));
		return dev;
	}

	return dev;
}
